##
## EPITECH PROJECT, 2018
## myIrc
## File description:
## Makefile
##

## Global Args

CC =	gcc

CFLAGS =	-W -Wall -Werror -Wextra -I./src -I./../utils

LIB =

CMP =	$(CC) $(CFLAGS) -o $@ $^ $(LIB)

PARAM =

## Args
SRC =	src/main.c \
		src/channel/channel.c \
		src/client/client.c \
		src/interpreter/interpreter.c \
		src/msg/msg.c \
		src/server/server.c \
		src/socket/socket.c \
		src/cmd/cmd_join.c \
		src/cmd/cmd_notice.c \
		src/cmd/cmd_list.c \
		src/cmd/cmd_names.c \
		src/cmd/cmd_nick.c \
		src/cmd/cmd_part.c \
		src/cmd/cmd_pass.c \
		src/cmd/cmd_privmsg.c \
		src/cmd/cmd_user.c \
		src/cmd/cmd_users.c \
		src/cmd/cmd_quit.c \
		src/cmd/cmd_ping_pong.c \
		../utils/list/exec.c \
		../utils/list/list.c \
		../utils/list/push.c \
		../utils/list/tab.c \
		../utils/gnl.c \
		../utils/data.c \
		../utils/free_strtab.c \
		../utils/len_strtab.c \
		../utils/strtab.c

OBJ =	$(SRC:.c=.o)

NAME =	../server

## Rule

%.o: %.c
	@$(CC) -c -o $@ $< $(CFLAGS)
	@printf "[\033[0;32mcompiled\033[0m] %s\n" $<

all: $(NAME)

$(NAME): $(OBJ)
	@$(CMP)
	@printf "[\033[0;36mbuilt\033[0m] %s\n" $(NAME)

run: re
	./$(NAME) $(PARAM)

debug:	CFLAGS += -g3
debug: re

rund: debug
	valgrind ./$(NAME) $(PARAM)

## Aux Rule

.PHONY: clean fclean

clean:
	@rm -f $(OBJ)
	@printf "[\033[0;31mdeleted\033[0m] %s\n" $(OBJ)

fclean:
	@rm -f $(NAME)
	@printf "[\033[0;31mdeleted\033[0m] %s\n" $(NAME)
